Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision e87acf50f98112d75e2652d26e782186d90e5f4e)
+++ src/builder.cpp	(revision 9879f6f8e5ad9364ccd32e2d6735f2ffc89cf18d)
@@ -483,11 +483,9 @@
       Log() << Verbose(0) << "Enter radius: ";
       cin >> tmp1;
-      first = mol->start;
-      second = first->next;
-      while(second != mol->end) {
-        first = second;
-        second = first->next;
-        if (first->x.DistanceSquared((const Vector *)&second->x) > tmp1*tmp1) // distance to first above radius ...
-          mol->RemoveAtom(first);
+      molecule::iterator runner;
+      for (molecule::iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+        runner = iter++;
+        if ((*iter)->x.DistanceSquared((const Vector *)&(*runner)->x) > tmp1*tmp1) // distance to first above radius ...
+          mol->RemoveAtom((*runner));
       }
       break;
@@ -499,12 +497,10 @@
       Log() << Verbose(0) << "Upper boundary: ";
       cin >> tmp2;
-      first = mol->start;
-      second = first->next;
-      while(second != mol->end) {
-        first = second;
-        second = first->next;
-        if ((first->x.x[axis] < tmp1) || (first->x.x[axis] > tmp2)) {// out of boundary ...
-          //Log() << Verbose(0) << "Atom " << *first << " with " << first->x.x[axis] << " on axis " << axis << " is out of bounds [" << tmp1 << "," << tmp2 << "]." << endl;
-          mol->RemoveAtom(first);
+      molecule::iterator runner;
+      for (molecule::iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+        runner = iter++;
+        if (((*runner)->x.x[axis] < tmp1) || ((*runner)->x.x[axis] > tmp2)) {// out of boundary ...
+          //Log() << Verbose(0) << "Atom " << *(*runner) << " with " << (*runner)->x.x[axis] << " on axis " << axis << " is out of bounds [" << tmp1 << "," << tmp2 << "]." << endl;
+          mol->RemoveAtom((*runner));
         }
       }
@@ -549,16 +545,14 @@
         min[i] = 0.;
 
-      second = mol->start;
-      while ((second->next != mol->end)) {
-        second = second->next; // advance
-        Z = second->type->Z;
+      for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+        Z = (*iter)->type->Z;
         tmp1 = 0.;
-        if (first != second) {
+        if (first != (*iter)) {
           x.CopyVector((const Vector *)&first->x);
-          x.SubtractVector((const Vector *)&second->x);
+          x.SubtractVector((const Vector *)&(*iter)->x);
           tmp1 = x.Norm();
         }
         if ((tmp1 != 0.) && ((min[Z] == 0.) || (tmp1 < min[Z]))) min[Z] = tmp1;
-        //Log() << Verbose(0) << "Bond length between Atom " << first->nr << " and " << second->nr << ": " << tmp1 << " a.u." << endl;
+        //Log() << Verbose(0) << "Bond length between Atom " << first->nr << " and " << (*iter)->nr << ": " << tmp1 << " a.u." << endl;
       }
       for (int i=MAX_ELEMENTS;i--;)
@@ -829,9 +823,7 @@
           vectors = new Vector *[count];
           j = 0;
-          first = mol->start;
-          while (first->next != mol->end) { // make a list of all atoms with coordinates and element
-            first = first->next;
-            Elements[j] = first->type;
-            vectors[j] = &first->x;
+          for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+            Elements[j] = (*iter)->type;
+            vectors[j] = &(*iter)->x;
             j++;
           }
@@ -1184,5 +1176,4 @@
     return;
   }
-  atom *Walker = mol->start;
 
   // generate some KeySets
@@ -1190,8 +1181,7 @@
   KeySet TestSets[mol->AtomCount+1];
   i=1;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
     for (int j=0;j<i;j++) {
-      TestSets[j].insert(Walker->nr);
+      TestSets[j].insert((*iter)->nr);
     }
     i++;
@@ -1199,12 +1189,15 @@
   Log() << Verbose(0) << "Testing insertion of already present item in KeySets." << endl;
   KeySetTestPair test;
-  test = TestSets[mol->AtomCount-1].insert(Walker->nr);
-  if (test.second) {
-    Log() << Verbose(1) << "Insertion worked?!" << endl;
+  molecule::const_iterator runner = mol->begin();
+  if (runner != mol->end()) {
+    test = TestSets[mol->AtomCount-1].insert((*runner)->nr);
+    if (test.second) {
+      Log() << Verbose(1) << "Insertion worked?!" << endl;
+    } else {
+      Log() << Verbose(1) << "Insertion rejected: Present object is " << (*test.first) << "." << endl;
+    }
   } else {
-    Log() << Verbose(1) << "Insertion rejected: Present object is " << (*test.first) << "." << endl;
+    eLog() << Verbose(1) << "No atoms to test on." << endl;
   }
-  TestSets[mol->AtomCount].insert(mol->end->previous->nr);
-  TestSets[mol->AtomCount].insert(mol->end->previous->previous->previous->nr);
 
   // constructing Graph structure
@@ -1810,12 +1803,10 @@
                 double tmp1 = atof(argv[argptr+1]);
                 atom *third = mol->FindAtom(atoi(argv[argptr]));
-                atom *first = mol->start;
-                if ((third != NULL) && (first != mol->end)) {
-                  atom *second = first->next;
-                  while(second != mol->end) {
-                    first = second;
-                    second = first->next;
-                    if (first->x.DistanceSquared((const Vector *)&third->x) > tmp1*tmp1) // distance to first above radius ...
-                      mol->RemoveAtom(first);
+                molecule::iterator runner;
+                if (third != NULL) {
+                  for (molecule::iterator iter = mol->begin(); iter != mol->end();) {
+                    runner = iter++;
+                    if ((*runner)->x.DistanceSquared((const Vector *)&third->x) > tmp1*tmp1) // distance to first above radius ...
+                      mol->RemoveAtom((*runner));
                   }
                 } else {
@@ -2082,9 +2073,7 @@
                     vectors = new Vector *[count];
                     j = 0;
-                    first = mol->start;
-                    while (first->next != mol->end) {  // make a list of all atoms with coordinates and element
-                      first = first->next;
-                      Elements[j] = first->type;
-                      vectors[j] = &first->x;
+                    for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+                      Elements[j] = (*iter)->type;
+                      vectors[j] = &(*iter)->x;
                       j++;
                     }
Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision e87acf50f98112d75e2652d26e782186d90e5f4e)
+++ src/config.cpp	(revision 9879f6f8e5ad9364ccd32e2d6735f2ffc89cf18d)
@@ -1542,5 +1542,4 @@
   int AtomNo = -1;
   int MolNo = 0;
-  atom *Walker = NULL;
   FILE *f = NULL;
 
@@ -1555,26 +1554,24 @@
   fprintf(f, "# Created by MoleCuilder\n");
 
-  for (MoleculeList::const_iterator Runner = MolList->ListOfMolecules.begin(); Runner != MolList->ListOfMolecules.end(); Runner++) {
-    Walker = (*Runner)->start;
+  for (MoleculeList::const_iterator MolRunner = MolList->ListOfMolecules.begin(); MolRunner != MolList->ListOfMolecules.end(); MolRunner++) {
     int *elementNo = Calloc<int>(MAX_ELEMENTS, "config::SavePDB - elementNo");
     AtomNo = 0;
-    while (Walker->next != (*Runner)->end) {
-      Walker = Walker->next;
-      sprintf(name, "%2s%2d",Walker->type->symbol, elementNo[Walker->type->Z]);
-      elementNo[Walker->type->Z] = (elementNo[Walker->type->Z]+1) % 100;   // confine to two digits
+    for (molecule::const_iterator iter = (*MolRunner)->begin(); iter != (*MolRunner)->end(); ++iter) {
+      sprintf(name, "%2s%2d",(*iter)->type->symbol, elementNo[(*iter)->type->Z]);
+      elementNo[(*iter)->type->Z] = (elementNo[(*iter)->type->Z]+1) % 100;   // confine to two digits
       fprintf(f,
              "ATOM %6u %-4s %4s%c%4u    %8.3f%8.3f%8.3f%6.2f%6.2f      %4s%2s%2s\n",
-             Walker->nr,                /* atom serial number */
+             (*iter)->nr,                /* atom serial number */
              name,         /* atom name */
-             (*Runner)->name,      /* residue name */
+             (*MolRunner)->name,      /* residue name */
              'a'+(unsigned char)(AtomNo % 26),           /* letter for chain */
              MolNo,         /* residue sequence number */
-             Walker->node->x[0],                 /* position X in Angstroem */
-             Walker->node->x[1],                 /* position Y in Angstroem */
-             Walker->node->x[2],                 /* position Z in Angstroem */
-             (double)Walker->type->Valence,         /* occupancy */
-             (double)Walker->type->NoValenceOrbitals,          /* temperature factor */
+             (*iter)->node->x[0],                 /* position X in Angstroem */
+             (*iter)->node->x[1],                 /* position Y in Angstroem */
+             (*iter)->node->x[2],                 /* position Z in Angstroem */
+             (double)(*iter)->type->Valence,         /* occupancy */
+             (double)(*iter)->type->NoValenceOrbitals,          /* temperature factor */
              "0",            /* segment identifier */
-             Walker->type->symbol,    /* element symbol */
+             (*iter)->type->symbol,    /* element symbol */
              "0");           /* charge */
       AtomNo++;
@@ -1596,5 +1593,4 @@
 {
   int AtomNo = -1;
-  atom *Walker = NULL;
   FILE *f = NULL;
 
@@ -1611,24 +1607,22 @@
   fprintf(f, "# Created by MoleCuilder\n");
 
-  Walker = mol->start;
   AtomNo = 0;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
-    sprintf(name, "%2s%2d",Walker->type->symbol, elementNo[Walker->type->Z]);
-    elementNo[Walker->type->Z] = (elementNo[Walker->type->Z]+1) % 100;   // confine to two digits
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+    sprintf(name, "%2s%2d",(*iter)->type->symbol, elementNo[(*iter)->type->Z]);
+    elementNo[(*iter)->type->Z] = (elementNo[(*iter)->type->Z]+1) % 100;   // confine to two digits
     fprintf(f,
            "ATOM %6u %-4s %4s%c%4u    %8.3f%8.3f%8.3f%6.2f%6.2f      %4s%2s%2s\n",
-           Walker->nr,                /* atom serial number */
+           (*iter)->nr,                /* atom serial number */
            name,         /* atom name */
            mol->name,      /* residue name */
            'a'+(unsigned char)(AtomNo % 26),           /* letter for chain */
            0,         /* residue sequence number */
-           Walker->node->x[0],                 /* position X in Angstroem */
-           Walker->node->x[1],                 /* position Y in Angstroem */
-           Walker->node->x[2],                 /* position Z in Angstroem */
-           (double)Walker->type->Valence,         /* occupancy */
-           (double)Walker->type->NoValenceOrbitals,          /* temperature factor */
+           (*iter)->node->x[0],                 /* position X in Angstroem */
+           (*iter)->node->x[1],                 /* position Y in Angstroem */
+           (*iter)->node->x[2],                 /* position Z in Angstroem */
+           (double)(*iter)->type->Valence,         /* occupancy */
+           (double)(*iter)->type->NoValenceOrbitals,          /* temperature factor */
            "0",            /* segment identifier */
-           Walker->type->symbol,    /* element symbol */
+           (*iter)->type->symbol,    /* element symbol */
            "0");           /* charge */
     AtomNo++;
@@ -1647,5 +1641,4 @@
 bool config::SaveTREMOLO(const char * const filename, const molecule * const mol) const
 {
-  atom *Walker = NULL;
   ofstream *output = NULL;
   stringstream * const fname = new stringstream;
@@ -1660,27 +1653,24 @@
 
   // scan maximum number of neighbours
-  Walker = mol->start;
   int MaxNeighbours = 0;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
-    const int count = Walker->ListOfBonds.size();
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+    const int count = (*iter)->ListOfBonds.size();
     if (MaxNeighbours < count)
       MaxNeighbours = count;
   }
-  *output << "# ATOMDATA Id name resName resSeq x=3 charge type neighbors=" << MaxNeighbours << endl;
-
-  Walker = mol->start;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
-    *output << Walker->nr << "\t";
-    *output << Walker->Name << "\t";
+  *output << "# ATOMDATA Id name resName resSeq x=3 Charge type neighbors=" << MaxNeighbours << endl;
+
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+    *output << (*iter)->nr << "\t";
+    *output << (*iter)->Name << "\t";
     *output << mol->name << "\t";
     *output << 0 << "\t";
-    *output << Walker->node->x[0] << "\t" << Walker->node->x[1] << "\t" << Walker->node->x[2] << "\t";
-    *output << (double)Walker->type->Valence << "\t";
-    *output << Walker->type->symbol << "\t";
-    for (BondList::iterator runner = Walker->ListOfBonds.begin(); runner != Walker->ListOfBonds.end(); runner++)
-      *output << (*runner)->GetOtherAtom(Walker)->nr << "\t";
-    for(int i=Walker->ListOfBonds.size(); i < MaxNeighbours; i++)
+    for (int i=0;i<NDIM;i++)
+      *output << (*iter)->node->x[i] << "\t";
+    *output << (double)(*iter)->type->Valence << "\t";
+    *output << (*iter)->type->symbol << "\t";
+    for (BondList::iterator runner = (*iter)->ListOfBonds.begin(); runner != (*iter)->ListOfBonds.end(); runner++)
+      *output << (*runner)->GetOtherAtom((*iter))->nr << "\t";
+    for(int i=(*iter)->ListOfBonds.size(); i < MaxNeighbours; i++)
       *output << "-\t";
     *output << endl;
@@ -1701,5 +1691,4 @@
 bool config::SaveTREMOLO(const char * const filename, const MoleculeListClass * const MolList) const
 {
-  atom *Walker = NULL;
   ofstream *output = NULL;
   stringstream * const fname = new stringstream;
@@ -1716,13 +1705,11 @@
   int MaxNeighbours = 0;
   for (MoleculeList::const_iterator MolWalker = MolList->ListOfMolecules.begin(); MolWalker != MolList->ListOfMolecules.end(); MolWalker++) {
-    Walker = (*MolWalker)->start;
-    while (Walker->next != (*MolWalker)->end) {
-      Walker = Walker->next;
-      const int count = Walker->ListOfBonds.size();
+    for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+      const int count = (*iter)->ListOfBonds.size();
       if (MaxNeighbours < count)
         MaxNeighbours = count;
     }
   }
-  *output << "# ATOMDATA Id name resName resSeq x=3 charge type neighbors=" << MaxNeighbours << endl;
+  *output << "# ATOMDATA Id name resName resSeq x=3 Charge type neighbors=" << MaxNeighbours << endl;
 
   // create global to local id map
@@ -1745,17 +1732,16 @@
     int AtomNo = 0;
     for (MoleculeList::const_iterator MolWalker = MolList->ListOfMolecules.begin(); MolWalker != MolList->ListOfMolecules.end(); MolWalker++) {
-      Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
+      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
         *output << AtomNo << "\t";
-        *output << Walker->Name << "\t";
+        *output << (*iter)->Name << "\t";
         *output << (*MolWalker)->name << "\t";
         *output << MolCounter << "\t";
-        *output << Walker->node->x[0] << "\t" << Walker->node->x[1] << "\t" << Walker->node->x[2] << "\t";
-        *output << (double)Walker->type->Valence << "\t";
-        *output << Walker->type->symbol << "\t";
-        for (BondList::iterator runner = Walker->ListOfBonds.begin(); runner != Walker->ListOfBonds.end(); runner++)
-          *output << LocalNotoGlobalNoMap[MolCounter][ (*runner)->GetOtherAtom(Walker)->nr ] << "\t";
-        for(int i=Walker->ListOfBonds.size(); i < MaxNeighbours; i++)
+        for (int i=0;i<NDIM;i++)
+          *output << (*iter)->node->x[i] << "\t";
+        *output << (double)(*iter)->type->Valence << "\t";
+        *output << (*iter)->type->symbol << "\t";
+        for (BondList::iterator runner = (*iter)->ListOfBonds.begin(); runner != (*iter)->ListOfBonds.end(); runner++)
+          *output << LocalNotoGlobalNoMap[MolCounter][ (*runner)->GetOtherAtom((*iter))->nr ] << "\t";
+        for(int i=(*iter)->ListOfBonds.size(); i < MaxNeighbours; i++)
           *output << "-\t";
         *output << endl;
Index: src/helpers.hpp
===================================================================
--- src/helpers.hpp	(revision e87acf50f98112d75e2652d26e782186d90e5f4e)
+++ src/helpers.hpp	(revision 9879f6f8e5ad9364ccd32e2d6735f2ffc89cf18d)
@@ -100,60 +100,4 @@
 };
 
-/** Creates a lookup table for true father's Atom::Nr -> atom ptr.
- * \param *start begin of chain list
- * \paran *end end of chain list
- * \param **Lookuptable pointer to return allocated lookup table (should be NULL on start)
- * \param count optional predetermined size for table (otherwise we set the count to highest true father id)
- * \return true - success, false - failure
- */
-template <typename T> bool CreateFatherLookupTable(T *start, T *end, T **&LookupTable, int count = 0)
-{
-  bool status = true;
-  T *Walker = NULL;
-  int AtomNo;
-
-  if (LookupTable != NULL) {
-    Log() << Verbose(0) << "Pointer for Lookup table is not NULL! Aborting ..." <<endl;
-    return false;
-  }
-
-  // count them
-  if (count == 0) {
-    Walker = start;
-    while (Walker->next != end) { // create a lookup table (Atom::nr -> atom) used as a marker table lateron
-      Walker = Walker->next;
-      count = (count < Walker->GetTrueFather()->nr) ? Walker->GetTrueFather()->nr : count;
-    }
-  }
-  if (count <= 0) {
-    Log() << Verbose(0) << "Count of lookup list is 0 or less." << endl;
-    return false;
-  }
-
-  // allocate and fill
-  LookupTable = Calloc<T*>(count, "CreateFatherLookupTable - **LookupTable");
-  if (LookupTable == NULL) {
-    eLog() << Verbose(0) << "LookupTable memory allocation failed!" << endl;
-    performCriticalExit();
-    status = false;
-  } else {
-    Walker = start;
-    while (Walker->next != end) { // create a lookup table (Atom::nr -> atom) used as a marker table lateron
-      Walker = Walker->next;
-      AtomNo = Walker->GetTrueFather()->nr;
-      if ((AtomNo >= 0) && (AtomNo < count)) {
-        //*out << "Setting LookupTable[" << AtomNo << "] to " << *Walker << endl;
-        LookupTable[AtomNo] = Walker;
-      } else {
-        Log() << Verbose(0) << "Walker " << *Walker << " exceeded range of nuclear ids [0, " << count << ")." << endl;
-        status = false;
-        break;
-      }
-    }
-  }
-
-  return status;
-};
-
 /** Frees a two-dimensional array.
  * \param *ptr pointer to array
Index: src/lists.hpp
===================================================================
--- src/lists.hpp	(revision e87acf50f98112d75e2652d26e782186d90e5f4e)
+++ src/lists.hpp	(revision 9879f6f8e5ad9364ccd32e2d6735f2ffc89cf18d)
@@ -8,6 +8,4 @@
 #ifndef LISTS_HPP_
 #define LISTS_HPP_
-
-class atom;
 
 /******************************** Some templates for list management ***********************************/
@@ -134,27 +132,3 @@
 };
 
-/** Returns the first marker in a chain list.
- * \param *me one arbitrary item in chain list
- * \return poiner to first marker
- */
-template <typename X> X *GetFirst(X *me)
-{
-  X *Binder = me;
-  while(Binder->previous != 0)
-    Binder = Binder->previous;
-  return Binder;
-};
-
-/** Returns the last marker in a chain list.
- * \param *me one arbitrary item in chain list
- * \return poiner to last marker
- */
-template <typename X> X *GetLast(X *me)
-{
-  X *Binder = me;
-  while(Binder->next != 0)
-    Binder = Binder->next;
-  return Binder;
-};
-
 #endif /* LISTS_HPP_ */
Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision e87acf50f98112d75e2652d26e782186d90e5f4e)
+++ src/molecule.cpp	(revision 9879f6f8e5ad9364ccd32e2d6735f2ffc89cf18d)
@@ -37,11 +37,6 @@
   formula(this,boost::bind(&molecule::calcFormula,this)),
   last_atom(0),
-  InternalPointer(start)
-{
-  // init atom chain list
-  //start->father = NULL;
-  //end->father = NULL;
-  //link(start,end);
-
+  InternalPointer(begin())
+{
   // init bond chain list
   link(first,last);
@@ -67,6 +62,4 @@
   delete(first);
   delete(last);
-  end->getWorld()->destroyAtom(end);
-  start->getWorld()->destroyAtom(start);
 };
 
@@ -103,6 +96,6 @@
   for (int j = 0; j<MAX_ELEMENTS;j++)
     Counts[j] = 0;
-  for(atom *Walker = start; Walker != end; Walker = Walker->next) {
-    Counts[Walker->type->Z]++;
+  for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
+    Counts[(*iter)->type->Z]++;
   }
   for(element* Elemental = elemente->end; Elemental != elemente->start; Elemental = Elemental->previous) {
@@ -124,10 +117,54 @@
 }
 
-molecule::iterator molecule::ende(){
+molecule::iterator molecule::end(){
   return molecule::iterator(atoms.end(),this);
 }
 
-molecule::const_iterator molecule::ende() const{
+molecule::const_iterator molecule::end() const{
   return atoms.end();
+}
+
+bool molecule::empty() const
+{
+  return (begin() == end());
+}
+
+size_t molecule::size() const
+{
+  size_t counter = 0;
+  for (molecule::const_iterator iter = begin(); iter != end (); ++iter)
+    counter++;
+  return counter;
+}
+
+molecule::const_iterator molecule::erase( const_iterator loc )
+{
+  molecule::const_iterator iter = loc;
+  iter--;
+  atoms.erase( loc );
+  return iter;
+}
+
+molecule::const_iterator molecule::erase( atom *& key )
+{
+  molecule::const_iterator iter = find(key);
+  molecule::const_iterator runner = iter;
+  if (runner != begin()) {
+    runner--;
+    if (iter != end())
+      atoms.erase( key );
+    return runner;
+  } else
+    return end();
+}
+
+molecule::const_iterator molecule::find ( atom *& key ) const
+{
+  return atoms.find( key );
+}
+
+pair<molecule::iterator,bool> molecule::insert ( atom * const key )
+{
+  return atoms.insert(key);
 }
 
@@ -139,9 +176,7 @@
 bool molecule::AddAtom(atom *pointer)
 {
-  bool retval = false;
   OBSERVE;
   if (pointer != NULL) {
     pointer->sort = &pointer->nr;
-    pointer->nr = last_atom++;  // increase number within molecule
     AtomCount++;
     if (pointer->type != NULL) {
@@ -157,7 +192,7 @@
       }
     }
-    retval = add(pointer, end);
-  }
-  return retval;
+    insert(pointer);
+  }
+  return true;
 };
 
@@ -175,6 +210,5 @@
     walker->Name = Malloc<char>(strlen(pointer->Name) + 1, "atom::atom: *Name");
     strcpy (walker->Name, pointer->Name);
-    walker->nr = last_atom++;  // increase number within molecule
-    add(walker, end);
+    insert(walker);
     if ((pointer->type != NULL) && (pointer->type->Z != 1))
       NoNonHydrogen++;
@@ -701,5 +735,6 @@
     ElementCount--;
   RemoveBonds(pointer);
-  return remove(pointer, start, end);
+  erase(pointer);
+  return true;
 };
 
@@ -718,5 +753,5 @@
   if (ElementsInMolecule[pointer->type->Z] == 0)  // was last atom of this element?
     ElementCount--;
-  unlink(pointer);
+  erase(pointer);
   return true;
 };
@@ -727,5 +762,7 @@
 bool molecule::CleanupMolecule()
 {
-  return (cleanup(first,last) && cleanup(start,end));
+  for (molecule::iterator iter = begin(); !empty(); iter = begin())
+      erase(iter);
+  return (cleanup(first,last));
 };
 
@@ -734,9 +771,13 @@
  * \return pointer to atom or NULL
  */
-atom * molecule::FindAtom(int Nr)  const{
-  atom * walker = find(&Nr, start,end);
-  if (walker != NULL) {
+atom * molecule::FindAtom(int Nr)  const
+{
+  molecule::const_iterator iter = begin();
+  for (; iter != end(); ++iter)
+    if ((*iter)->nr == Nr)
+      break;
+  if (iter != end()) {
     //Log() << Verbose(0) << "Found Atom Nr. " << walker->nr << endl;
-    return walker;
+    return (*iter);
   } else {
     Log() << Verbose(0) << "Atom not found in list." << endl;
@@ -896,10 +937,5 @@
 void molecule::CountAtoms()
 {
-  int i = 0;
-  atom *Walker = start;
-  while (Walker->next != end) {
-    Walker = Walker->next;
-    i++;
-  }
+  int i = size();
   if ((AtomCount == 0) || (i != AtomCount)) {
     Log() << Verbose(3) << "Mismatch in AtomCount " << AtomCount << " and recounted number " << i << ", renaming all." << endl;
@@ -910,14 +946,12 @@
       i=0;
       NoNonHydrogen = 0;
-      Walker = start;
-      while (Walker->next != end) {
-        Walker = Walker->next;
-        Walker->nr = i;   // update number in molecule (for easier referencing in FragmentMolecule lateron)
-        if (Walker->type->Z != 1) // count non-hydrogen atoms whilst at it
+      for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
+        (*iter)->nr = i;   // update number in molecule (for easier referencing in FragmentMolecule lateron)
+        if ((*iter)->type->Z != 1) // count non-hydrogen atoms whilst at it
           NoNonHydrogen++;
-        Free(&Walker->Name);
-        Walker->Name = Malloc<char>(6, "molecule::CountAtoms: *walker->Name");
-        sprintf(Walker->Name, "%2s%02d", Walker->type->symbol, Walker->nr+1);
-        Log() << Verbose(3) << "Naming atom nr. " << Walker->nr << " " << Walker->Name << "." << endl;
+        Free(&(*iter)->Name);
+        (*iter)->Name = Malloc<char>(6, "molecule::CountAtoms: *walker->Name");
+        sprintf((*iter)->Name, "%2s%02d", (*iter)->type->symbol, (*iter)->nr+1);
+        Log() << Verbose(3) << "Naming atom nr. " << (*iter)->nr << " " << (*iter)->Name << "." << endl;
         i++;
       }
@@ -1092,5 +1126,4 @@
 int * molecule::GetFatherSonAtomicMap(molecule *OtherMolecule)
 {
-  atom *Walker = NULL, *OtherWalker = NULL;
   Log() << Verbose(3) << "Begin of GetFatherAtomicMap." << endl;
   int *AtomicMap = Malloc<int>(AtomCount, "molecule::GetAtomicMap: *AtomicMap");
@@ -1103,21 +1136,17 @@
   } else {
     Log() << Verbose(4) << "Map is ";
-    Walker = start;
-    while (Walker->next != end) {
-      Walker = Walker->next;
-      if (Walker->father == NULL) {
-        AtomicMap[Walker->nr] = -2;
+    for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
+      if ((*iter)->father == NULL) {
+        AtomicMap[(*iter)->nr] = -2;
       } else {
-        OtherWalker = OtherMolecule->start;
-        while (OtherWalker->next != OtherMolecule->end) {
-          OtherWalker = OtherWalker->next;
+        for (molecule::const_iterator runner = OtherMolecule->begin(); runner != OtherMolecule->end(); ++runner) {
       //for (int i=0;i<AtomCount;i++) { // search atom
         //for (int j=0;j<OtherMolecule->AtomCount;j++) {
-          //Log() << Verbose(4) << "Comparing father " << Walker->father << " with the other one " << OtherWalker->father << "." << endl;
-          if (Walker->father == OtherWalker)
-            AtomicMap[Walker->nr] = OtherWalker->nr;
+          //Log() << Verbose(4) << "Comparing father " << (*iter)->father << " with the other one " << (*runner)->father << "." << endl;
+          if ((*iter)->father == (*runner))
+            AtomicMap[(*iter)->nr] = (*runner)->nr;
         }
       }
-      Log() << Verbose(0) << AtomicMap[Walker->nr] << "\t";
+      Log() << Verbose(0) << AtomicMap[(*iter)->nr] << "\t";
     }
     Log() << Verbose(0) << endl;
@@ -1153,8 +1182,6 @@
 void molecule::SetIndexedArrayForEachAtomTo ( atom **array, int ParticleInfo::*index) const
 {
-  atom *Walker = start;
-  while (Walker->next != end) {
-    Walker = Walker->next;
-    array[(Walker->*index)] = Walker;
+  for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
+    array[((*iter)->*index)] = (*iter);
   }
 };
Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision e87acf50f98112d75e2652d26e782186d90e5f4e)
+++ src/molecule.hpp	(revision 9879f6f8e5ad9364ccd32e2d6735f2ffc89cf18d)
@@ -137,4 +137,10 @@
   iterator end();
   const_iterator end() const;
+  bool empty() const;
+  size_t size() const;
+  const_iterator erase( const_iterator loc );
+  const_iterator erase( atom *& key );
+  const_iterator find (  atom *& key ) const;
+  pair<iterator,bool> insert ( atom * const key );
 
 
@@ -143,10 +149,7 @@
   Vector *GetCenter() const ;
   TesselPoint *GetPoint() const ;
-  TesselPoint *GetTerminalPoint() const ;
   int GetMaxId() const;
   void GoToNext() const ;
-  void GoToPrevious() const ;
   void GoToFirst() const ;
-  void GoToLast() const ;
   bool IsEmpty() const ;
   bool IsEnd() const ;
@@ -310,4 +313,5 @@
   bool StoreForcesFile(MoleculeListClass *BondFragments, char *path, int *SortIndex);
   bool CreateMappingLabelsToConfigSequence(int *&SortIndex);
+  bool CreateFatherLookupTable(atom **&LookupTable, int count = 0);
   void BreadthFirstSearchAdd(molecule *Mol, atom **&AddedAtomList, bond **&AddedBondList, atom *Root, bond *Bond, int BondOrder, bool IsAngstroem);
   /// -# BOSSANOVA
@@ -338,5 +342,5 @@
   private:
   int last_atom;      //!< number given to last atom
-  mutable atom *InternalPointer;  //!< internal pointer for PointCloud
+  mutable iterator InternalPointer;  //!< internal pointer for PointCloud
 };
 
